def produit_matrices_2_2(lst1,lst2) :
    """produit de deux matrices 2x2 présentées sous forme de liste à 4 éléments"""
    return [lst1[0]*lst2[0]+lst1[1]*lst2[2],lst1[0]*lst2[1]+lst1[1]*lst2[3],
            lst1[2]*lst2[0]+lst1[3]*lst2[2],lst1[2]*lst2[1]+lst1[3]*lst2[3]]


lst1 = [1,1,1,0]
lst2 = [1,1,1,0]

#print(produit_matrices_2_2(lst1,lst2))

n = 17

def exp_bin_mat(a,n) :
    """calcul de a^n où est une matrice 2x2 par exponentiation binaire"""
    res = [1,0,0,1]
    m = n
    puiss_a = a.copy() 
    while (m != 0) :
        if (m%2 == 1) :
            res = produit_matrices_2_2(res,puiss_a) 
        puiss_a = produit_matrices_2_2(puiss_a,puiss_a) 
        m = m//2
    return res

print(exp_bin_mat(lst1,n))



def fibo(n) :
    """renvoie le terme de rang n de la suite de Fibonacci (version récursive)"""
    if ((n==0) or (n==1)) :
        return 1
    else :
        return fibo(n-1) + fibo(n-2)

print(fibo(n))



def fibo2(n,a,b) :
    """Quasi-Fibonacci où a et b sont les deux premiers termes respectifs de la suite"""
    if (n==0) :
        return a
    elif (n==1) :
        return b
    else :
        return fibo2(n-1,b,a+b)

print(fibo2(n,1,1)) 

